Imports System.Drawing

Imports MindFusion.Diagramming
Imports MindFusion.Diagramming.Lanes

Imports LinearGradientBrush = MindFusion.Drawing.LinearGradientBrush
Imports SolidBrush = MindFusion.Drawing.SolidBrush
Imports Pen = MindFusion.Drawing.Pen

Partial Class _Default
	Inherits System.Web.UI.Page

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		If Not IsPostBack Then
			'Dim diagram As Diagram = diagramView.Diagram

			'' Initialize grid
			'Dim grid As Grid = diagram.LaneGrid

			'grid.HookHeaders = True
			'grid.HeadersOnTop = True
			'grid.RowHeadersWidths = New Single() {30}
			'grid.ColumnHeadersHeights = New Single() {15}
			'grid.MinHeaderSize = 17
			'grid.AlignCells = True

			'Dim i As Integer
			'For i = 0 To 11
			'	grid.ColumnHeaders.Add(New Header(New DateTime(2009, i + 1, 1).ToString("MMM yyyy")))
			'Next i

			'Dim headers As String()
			'headers = New String() { _
			' "Group 1 - Activity A", _
			' "Group 1 - Activity B", _
			' "Group 1 - Activity C", _
			' "Group 2 - Activity D", _
			' "Group 2 - Activity E", _
			' "Group 2 - Activity F"}

			'For i = 0 To 5 Step 1
			'	grid.RowHeaders.Add(New Header(headers(i)))
			'Next

			'For i = 0 To grid.ColumnHeaders.Count - 1
			'	Dim column As Header = grid.GetColumn(i)
			'	grid(column, Nothing).Style.LeftBorderPen = New Pen(Color.White)
			'	grid(column, Nothing).Style.RightBorderPen = Nothing
			'	grid(column, Nothing).Style.BackgroundBrush = New SolidBrush(Color.AliceBlue)
			'Next

			'For i = 0 To grid.RowHeaders.Count - 1
			'	Dim row As Header = grid.GetRow(i)
			'	grid(Nothing, row).Style.TopBorderPen = New Pen(Color.White)
			'	grid(Nothing, row).Style.BottomBorderPen = Nothing
			'Next

			'For i = 0 To grid.ColumnHeaders.Count - 1
			'	grid.ColumnHeaders(i).Style.RightBorderPen = Nothing
			'	grid.ColumnHeaders(i).Style.TopBorderPen = Nothing
			'	grid.ColumnHeaders(i).Style.LeftBorderPen = New Pen(Color.White)
			'	grid.ColumnHeaders(i).Style.BottomBorderPen = New Pen(Color.White)
			'	grid.ColumnHeaders(i).Style.BackgroundBrush = _
			'	 New LinearGradientBrush(Color.MidnightBlue, Color.CornflowerBlue, 90)
			'	grid.ColumnHeaders(i).TitleColor = Color.White
			'Next

			'For i = 0 To grid.RowHeaders.Count - 1
			'	grid.RowHeaders(i).Style.RightBorderPen = New Pen(Color.White)
			'	grid.RowHeaders(i).Style.LeftBorderPen = New Pen(Color.White)
			'	grid.RowHeaders(i).Style.BottomBorderPen = New Pen(Color.White)
			'	grid.RowHeaders(i).Style.TopBorderPen = Nothing
			'	grid.RowHeaders(i).Style.BackgroundBrush = New SolidBrush(Color.CornflowerBlue)
			'	grid.RowHeaders(i).TitleColor = Color.White
			'Next
			Dim diagram As Diagram = diagramView.Diagram

			Dim headerFont As New Font("Trebuchet MS", 8.5F)

			Dim dashPen As New Pen(Color.FromArgb(230, 231, 233), 0)
			dashPen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash
			Dim borderPen As New Pen(Color.FromArgb(210, 211, 213), 0)
			Dim whitePen As New Pen(Color.White, 0)
			Dim primaryColor As Color = Color.FromArgb(&H94, &HA5, &HBD)
			Dim secondaryColor As Color = Color.FromArgb(&H39, &H39, &H50)

			' Initialize grid
			Dim grid As Grid = diagram.LaneGrid

			grid.HookHeaders = True
			grid.HeadersOnTop = True
			grid.RowHeadersWidths = New Single() {10, 30}
			grid.ColumnHeadersHeights = New Single() {15}
			grid.MinHeaderSize = 17
			grid.AlignCells = True

			Dim i As Integer
			For i = 0 To 11
				Dim header As New Header(New DateTime(DateTime.Today.Year, i + 1, 1).ToString("MMM yyyy"))
				header.TitleFont = headerFont
				grid.ColumnHeaders.Add(header)
			Next i

			Dim g1Headers = New String() { _
			 "Activity A", _
			 "Activity B", _
			 "Activity C" _
			   }
			Dim g2Headers = New String() { _
			 "Activity D", _
			 "Activity E", _
			 "Activity F" _
			 }

			Dim g1Header = New Header("Group 1")
			g1Header.TitleFont = headerFont
			g1Header.RotateTitle = True
			grid.RowHeaders.Add(g1Header)
			For i = 0 To g1Headers.Length - 1
				Dim header As New Header(g1Headers(i))
				header.TitleFont = headerFont
				g1Header.SubHeaders.Add(header)
			Next i

			Dim g2Header As New Header("Group 2")
			g2Header.TitleFont = headerFont
			g2Header.RotateTitle = True
			grid.RowHeaders.Add(g2Header)
			For i = 0 To g2Headers.Length - 1
				Dim header As New Header(g2Headers(i))
				header.TitleFont = headerFont
				g2Header.SubHeaders.Add(header)
			Next i

			Dim nullHeader As Header = Nothing
			Dim cellStyle As MindFusion.Diagramming.Lanes.Style = grid(nullHeader, nullHeader).Style
			cellStyle.LeftBorderPen = Nothing
			cellStyle.TopBorderPen = Nothing
			cellStyle.RightBorderPen = dashPen
			cellStyle.BottomBorderPen = dashPen

			cellStyle = grid(nullHeader, grid.RowHeaders(grid.RowHeaders.Count - 1)).Style
			cellStyle.BottomBorderPen = borderPen

			cellStyle = grid(grid.ColumnHeaders(grid.ColumnHeaders.Count - 1), Nothing).Style
			cellStyle.RightBorderPen = borderPen

			For i = 0 To grid.ColumnHeaders.Count - 1
				Dim header As Header = grid.ColumnHeaders(i)
				If (i = grid.ColumnHeaders.Count - 1) Then
					header.Style.RightBorderPen = borderPen
				Else
					header.Style.RightBorderPen = whitePen
				End If
				header.Style.TopBorderPen = borderPen
				header.Style.LeftBorderPen = Nothing
				header.Style.BottomBorderPen = borderPen
				header.Style.BackgroundBrush = New LinearGradientBrush(secondaryColor, primaryColor, 90)
				header.TitleColor = Color.White
			Next i

			For i = 0 To grid.RowHeaders.Count - 1
				Dim header As Header = grid.RowHeaders(i)
				header.Style.RightBorderPen = whitePen
				header.Style.LeftBorderPen = borderPen
				If (i = grid.RowHeaders.Count - 1) Then
					header.Style.BottomBorderPen = borderPen
				Else
					header.Style.BottomBorderPen = whitePen
				End If
				header.Style.TopBorderPen = Nothing
				header.Style.BackgroundBrush = New SolidBrush(primaryColor)
				header.TitleColor = Color.White

				Dim j As Integer
				For j = 0 To header.SubHeaders.Count - 1
					Dim subheader As Header = header.SubHeaders(j)
					subheader.Style.RightBorderPen = borderPen
					subheader.Style.LeftBorderPen = Nothing
					If (i = grid.RowHeaders.Count - 1 And j = header.SubHeaders.Count - 1) Then
						subheader.Style.BottomBorderPen = borderPen
					Else
						subheader.Style.BottomBorderPen = whitePen
					End If
					subheader.Style.TopBorderPen = Nothing
					subheader.Style.BackgroundBrush = New SolidBrush(primaryColor)
					subheader.TitleColor = Color.White
				Next j
			Next i

			Dim rowStyle As New MindFusion.Diagramming.Lanes.Style()
			rowStyle.LeftBorderPen = borderPen
			rowStyle.RightBorderPen = whitePen
			rowStyle.BottomBorderPen = whitePen
			rowStyle.TopBorderPen = borderPen
			rowStyle.BackgroundBrush = New LinearGradientBrush(secondaryColor, primaryColor, 90)
			grid.TopLeftAreaStyle = rowStyle

			diagram.EnableLanes = True
			diagram.BackBrush = New MindFusion.Drawing.SolidBrush(Color.White)
			diagram.DefaultShape = Shape.FromId("Rectangle")

			Dim bounds As RectangleF = RectangleF.Union(diagram.LaneGrid.GetRowHeaderBounds(), diagram.LaneGrid.GetColumnHeaderBounds())
			diagram.Bounds = New RectangleF(0, 0, bounds.Right, bounds.Bottom)

			'Add some nodes and links
			diagram.Factory.CreateShapeNode(GetAreaBounds(diagram.LaneGrid, 0, 0, 4, 0))
			diagram.Factory.CreateShapeNode(GetAreaBounds(diagram.LaneGrid, 1, 1, 4, 1))
			diagram.Factory.CreateShapeNode(GetAreaBounds(diagram.LaneGrid, 2, 2, 4, 2))

			diagram.Factory.CreateShapeNode(GetAreaBounds(diagram.LaneGrid, 5, 3, 9, 3))
			diagram.Factory.CreateShapeNode(GetAreaBounds(diagram.LaneGrid, 5, 4, 11, 4))
			diagram.Factory.CreateShapeNode(GetAreaBounds(diagram.LaneGrid, 10, 5, 11, 5))

			'Customize the nodes some nodes
			Dim style1 = New ShapeNodeStyle()
			style1.Brush = New LinearGradientBrush(Color.Green, Color.LawnGreen, 90)
			style1.Effects.Add(New AeroEffect())
			Dim style2 = New ShapeNodeStyle()
			style2.Brush = New LinearGradientBrush(Color.Firebrick, Color.OrangeRed, 90)
			style2.Effects.Add(New AeroEffect())

			For i = 0 To diagram.Nodes.Count - 1
				Dim shapenode As ShapeNode = CType(diagram.Nodes(i), ShapeNode)
				shapenode.Text = String.Format("Activity node {0}", i + 1)
				If i < 3 Then
					shapenode.Style = style1
				Else
					shapenode.Style = style2
				End If
			Next

			'Create a default style for ShapeNodes 
			Dim style As New ShapeNodeStyle()
			style.FontFamily = "Trebuchet MS"
			style.FontSize = 8.5F
			style.FontStyle = FontStyle.Bold
			style.Effects.Add(New AeroEffect())
			style.Stroke = New SolidBrush(Color.DimGray)
			style.TextBrush = New SolidBrush(Color.FromArgb(&H30, &H30, &H30))
			style.ShadowBrush = New SolidBrush(Color.Transparent)
			style.Brush = New LinearGradientBrush(Color.OrangeRed, Color.Orange, 90)
			Dim theme As New Theme()
			theme.RegisterStyle(GetType(ShapeNode), style)
			diagram.Theme = theme
		End If
	End Sub

	Private Function GetAreaBounds(grid As Grid, left As Integer, top As Integer, right As Integer, bottom As Integer) As RectangleF

		Return GetAreaBounds(grid.GetCellBounds(left, top), grid.GetCellBounds(right, bottom))

	End Function

	Private Function GetAreaBounds(bounds1 As RectangleF, bounds2 As RectangleF) As RectangleF

		Dim bounds As RectangleF = RectangleF.Union(bounds1, bounds2)
		bounds.Inflate(-2, -3)
		bounds.Width -= 1
		bounds.Height -= 1
		Return bounds

	End Function

	Shared n As Integer = 1

	Sub diagramView_NodeCreated(ByVal sender As Object, ByVal e As NodeEventArgs) Handles diagramView.NodeCreated

		If TypeOf e.Node Is ShapeNode Then
			Dim shape As ShapeNode = CType(e.Node, ShapeNode)
			shape.Text = String.Format("New node {0}", n)
		End If

		If TypeOf e.Node Is TableNode Then
			Dim table As TableNode = CType(e.Node, TableNode)
			table.Caption = String.Format("New node {0}", n)
		End If

		n += 1
		lblStatus.Text = String.Format("New node created at X={0},Y={1}", e.Node.Bounds.X, e.Node.Bounds.Y)

		If TypeOf e.Node Is ShapeNode Then
			Dim shape As ShapeNode = CType(e.Node, ShapeNode)
			UpdateNodeBounds(shape)
		End If
	End Sub

	Private Sub UpdateNodeBounds(node As DiagramNode)

		' Align the node to the nearest cells
		Dim cell1Bounds As RectangleF = RectangleF.Empty
		Dim cell2Bounds As RectangleF = RectangleF.Empty
		Dim grid As Grid = node.Parent.LaneGrid
		If (grid.GetCellFromPoint(New PointF(node.Bounds.Left, node.Bounds.Top), cell1Bounds) IsNot Nothing And _
		 grid.GetCellFromPoint(New PointF(node.Bounds.Right, node.Bounds.Top), cell2Bounds) IsNot Nothing) Then
			node.Bounds = GetAreaBounds(cell1Bounds, cell2Bounds)
		End If

	End Sub

	Private Shared Function GetLabel(ByVal node As DiagramNode) As String

		Dim label As String = ""

		If TypeOf node Is ShapeNode Then
			Dim shape As ShapeNode = CType(node, ShapeNode)
			label = shape.Text
		End If

		If TypeOf node Is TableNode Then
			Dim table As TableNode = CType(node, TableNode)
			label = table.Caption
		End If

		Return label
	End Function

	Sub diagramView_NodeDeleted(ByVal sender As Object, ByVal e As NodeEventArgs) Handles diagramView.NodeDeleted
		lblStatus.Text = String.Format("Node '{0}' deleted", GetLabel(e.Node))
	End Sub

	Sub diagramView_NodeModified(ByVal sender As Object, ByVal e As NodeEventArgs) Handles diagramView.NodeModified
		lblStatus.Text = String.Format( _
		   "Node '{0}' modified by {1} handle", _
		   GetLabel(e.Node), e.AdjustmentHandle)

		If (TypeOf e.Node Is ShapeNode) Then
			UpdateNodeBounds(e.Node)
		End If
	End Sub

	Sub diagramView_NodeClicked(ByVal sender As Object, ByVal e As NodeEventArgs) Handles diagramView.NodeClicked
		lblStatus.Text = String.Format("Node '{0}' clicked", GetLabel(e.Node))
	End Sub

	Protected Sub behavior_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles behavior.SelectedIndexChanged

		Select Case (behavior.SelectedIndex)

			Case 0
				diagramView.Behavior = MindFusion.Diagramming.Behavior.Modify
			Case 1
				diagramView.Behavior = MindFusion.Diagramming.Behavior.DrawShapes
			Case 2
				diagramView.Behavior = MindFusion.Diagramming.Behavior.LinkShapes
			Case 3
				diagramView.Behavior = MindFusion.Diagramming.Behavior.DrawTables
			Case 4
				diagramView.Behavior = MindFusion.Diagramming.Behavior.LinkTables
			Case 5
				diagramView.Behavior = MindFusion.Diagramming.Behavior.DrawLinks
			Case 6
				diagramView.Behavior = MindFusion.Diagramming.Behavior.DoNothing

		End Select

	End Sub
End Class